#include <allegro.h>

int main(void)
{
    BITMAP *dblbuffer;
    int x;

    allegro_init();

    install_keyboard();
    install_timer();        /* needed for `rest' function */

    if (set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0) < 0) {
	allegro_message("Couldn't set gfx mode: %s\n", allegro_error);
	exit(1);
    }
    clear(screen);

    circlefill(screen, 0, 100, 50, 15);         /* draw first time */
    for (x = 1; x < 320; x++) {
	rest(10);                               /* slow it down so we can see it */
	circlefill(screen, x - 1, 100, 50, 0);  /* erase from last place */
	circlefill(screen, x, 100, 50, 15);     /* redraw at new place */
	textout(screen, font, "No buffering (mode 13h)", 0, 0, 15);
    }

    // Pay attention!!! We HAVE to allocate memory for our memory bitmap
    dblbuffer = create_bitmap(SCREEN_W, SCREEN_H);
    clear(dblbuffer);

    circlefill(dblbuffer, 0, 100, 50, 15);	/* draw first time */

    vsync();
    blit(dblbuffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

    for (x = 1; x < 320; x++) {
	rest(10);		/* slow it down so we can see it */
	circlefill(dblbuffer, x - 1, 100, 50, 0);	/* erase from last place */
	circlefill(dblbuffer, x, 100, 50, 15);	/* redraw at new place */
	textout(dblbuffer, font, "Double buffering (mode 13h)", 0, 0, 15);

	vsync();
	blit(dblbuffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
    }

    // Now, remember to FREE the memory you previously allocated
    destroy_bitmap(dblbuffer);

    return 0;
}
END_OF_MAIN()

