#include <stdio.h>
#include <stdlib.h>
#include <allegro.h>
#include "0532sl.h"
#include "0532s.h"

void init(void)
{
    int i;

    for (i = 0; i < MAX_NODES; i++) {
	node[i] = malloc(sizeof(struct linked_list_node));

	if (node == NULL) {
	    allegro_exit();
	    allegro_message("Not enough memory");
	    exit(1);
	}
	node[i]->number = -1;
	node[i]->next = NULL;
    }

    // Initialization of the dummy node and some other nodes
    node[0]->number = 0;
    node[0]->next = node[1];
    node[1]->number = 7;
    node[1]->next = node[2];
    node[2]->number = 3;
    node[2]->next = node[3];
    node[3]->number = 8;
    node[3]->next = NULL;

    how_many_nodes = 4;
}

// Returns the index entry of the first found free node
int free_node(void)
{
    int i;

    for (i = 0; i < MAX_NODES; i++)
	if (node[i]->number < 0)
	    return i;

    return 0;
}

// Searches the node list, and returns the last used node in the node list
struct linked_list_node *search_last_node(void)
{
    int i;
    struct linked_list_node *temp;

    temp = node[0];
    i = 0;

    while (temp->next != NULL) {
	temp = temp->next;
	i++;
    }

    return temp;
}

// Searches for a specific number, and returns the previous node
struct linked_list_node *search_exact_number(int number)
{
    struct linked_list_node *temp;

    temp = node[0];

    while (temp->next != NULL) {
	if ((temp->next)->number == number)
	    return temp;

	temp = temp->next;
    }

    return NULL;
}

// Function to delete a node. The first node which matches number is deleted
void delete_number(void)
{
    int number;
    struct linked_list_node *temp, *which_node;

    if (how_many_nodes > 1) {
	textprintf(screen, font, 0, SCREEN_H - 10, 15,
		   "Please type the number to delete   ");
	do {
		number = ((readkey() & 0xff) - '0');
	} while ((number < 0) || (number > 9));

	which_node = search_exact_number(number);

	if (which_node == NULL) {
	    textprintf(screen, font, 0, SCREEN_H - 10, 15,
		       "Sorry, did not find the number    ");
	    rest(3000);
	    return;
	}
	which_node->next->number = -1;

	temp = (which_node->next)->next;

	(which_node->next)->next = NULL;

	which_node->next = temp;

	how_many_nodes--;
    } else {
	textprintf(screen, font, 0, SCREEN_H - 10, 15,
		   "Sorry, no nodes to delete     ");
	rest(3000);
    }
}

// Function to add a node. Nodes are added to the end of the list.
void add_number(void)
{
    int number;
    struct linked_list_node *temp, *last_node;

    if (how_many_nodes < MAX_NODES) {
	textprintf(screen, font, 0, SCREEN_H - 10, 15,
		   "Please type a number");
	do {
		number = ((readkey() & 0xff) - '0');
	} while ((number < 0) || (number > 9));

	last_node = search_last_node();

	temp = node[free_node()];

	temp->number = number;
	temp->next = NULL;
	last_node->next = temp;
	how_many_nodes++;
    } else {
	textprintf(screen, font, 0, SCREEN_H - 10, 15,
		   "Sorry, the list is full");
	rest(3000);
    }
}
