#include <stdlib.h>
#include <allegro.h>
#include "0532uc.h"
#include "0532ul.h"
#include "0532u.h"

// Returns the index entry of the first found free node
int free_node(void)
{
    int i;

    for (i = 0; i < MAX_CIRCLES; i++)
	if (circles[i] == NULL)
	    return i;

    return 0;
}

// Returns the index entry of the first found used node
int used_node(void)
{
    int i;

    for (i = 1; i < MAX_CIRCLES; i++)
	if (circles[i] != NULL)
	    return i;

    return 0;
}

// Searches the node list, and returns the last used node in the node list
CIRCLE_T *search_last_node(void)
{
    int i;
    CIRCLE_T *temp;

    temp = circles[0];
    i = 0;

    while (temp->next != NULL) {
	temp = temp->next;
	i++;
    }

    return temp;
}

// Function to delete a node. The first node which matches number is deleted
void delete_circle(void)
{
    int used;

    if (active_circles > 1) {

	used = used_node();

	circle_destroy(circles[used]);
	circles[used] = NULL;

	active_circles--;
    } else
	action = ADDING;
}

// Function to add a node. Nodes are added to the end of the list.
void add_circle(void)
{
    CIRCLE_T *last_node;

    if (active_circles - 1 < MAX_CIRCLES && active_circles - 1 < how_many_circles) {

	last_node = search_last_node();

	circles[free_node()] = circle_init((rand() % (SCREEN_W - 20)) + 10,
				       (rand() % (SCREEN_H - 20)) + 10,
					   (rand() % 25) + 5,
					   (rand() % 15) + 1,
					   (rand() % 7) - 3,
					   (rand() % 7) - 3,
					   last_node);

	active_circles++;
    } else
	action = SUBSTRACTING;
}
