#include <stdio.h>
#include <allegro.h>

int init_our_joystick()
{
    int i;

    // First call to init_joystick checks to see it there's any at all...
    if (install_joystick(JOY_TYPE_AUTODETECT) != 0) {
	printf("Sorry, didn't detect any joystick\n");
	return 1;
    }
    printf("\nWelcome to the calibration of your analogue joystick(s)\n");
    printf("Center stick 1 and press a button\n");
    readkey();

    install_joystick(JOY_TYPE_AUTODETECT);

    for (i = 0; i < num_joysticks; i++) {
	while (joy[i].flags & JOYFLAG_CALIBRATE) {
	    char *msg = calibrate_joystick_name(i);
	    printf("%s, and press a key\n", msg);
	    readkey();
	    if (calibrate_joystick(i) != 0) {
		printf("oops!\n");
		return 2;
	    }
	}

	printf("Now center the stick and press a key\n");
	readkey();
    }

    return 0;

}

int main(void)
{
    int ret;

    allegro_init();
    install_keyboard();

    ret = init_our_joystick();

    if (ret != 0)
	return ret;		// Return the error code of the joystick initialisation.

    printf("\nWell done! You have calibrated successfully your joystick(s).\n\n");
    return 0;
}
END_OF_MAIN()
