#include <stdio.h>
#include <time.h>
#include <string.h>
#include <allegro.h>
#include "0631.h"

int end_game;			/* flag we'll set to end the game */
int mouse_buttons;		// Number of buttons the mouse has

int button_state;		// Last state of the mouse buttons

int button_state_changes;	// Do we have to redraw the screen?

int range_changes;		// Do we have to redraw the screen?

int rang_x1, rang_x2, rang_y1, rang_y2;		// Range coordinates

int main(void)
{
    allegro_init();		/* initialise the Allegro library */
    init();			/* initialise the game */

    end_game = 0;		/* reset flag */

    do {			/* loop */
	input();		/* get input */
	process();		/* process it */
    } while (end_game == 0);	/* until the flag is set */

    allegro_exit();		/* just for luck */
    return 0;			/* tell the OS that all went well */
}
END_OF_MAIN()

void init(void)
{
    srand(time(NULL));
    install_keyboard();
    install_timer();
    mouse_buttons = install_mouse();

    if (mouse_buttons < 1) {
	allegro_message("Sorry, didn't detect any mouse there...\n");
	exit(1);
    }
    if (set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0) < 0) {
	allegro_message("Couldn't set gfx mode: %s\n", allegro_error);
	exit(2);
    }
    set_palette(desktop_palette);
    clear(screen);

    button_state_changes = 1;
    range_changes = 1;
}

void input(void)
{
    if (button_state != mouse_b) {
	button_state = mouse_b;
	button_state_changes++;
    }
    if (keypressed())
	range_changes++;

    if (key[KEY_ESC])
	end_game++;
}

void process(void)
{
    char text[255];

    if (range_changes) {

	show_mouse(NULL);
	rang_x1 = rand() % (SCREEN_W - 1);
	rang_y1 = rand() % (SCREEN_H - 51);
	rang_x2 = rang_x1 + rand() % (SCREEN_W - 50 - rang_x1);
	rang_y2 = rang_y1 + rand() % (SCREEN_H - 50 - rang_y1);

	rectfill(screen, 0, 0, 319, 150, makecol8(255, 255, 255));
	textout_centre(screen, font, "Press any key to change mouse range",
		       SCREEN_W >> 1, 5, makecol8(0, 0, 0));
	rect(screen, rang_x1, rang_y1, rang_x2, rang_y2, makecol8(0, 0, 0));
	set_mouse_range(rang_x1, rang_y1, rang_x2, rang_y2);

	show_mouse(screen);

	clear_keybuf();
	range_changes = 0;
    }
    if (button_state_changes) {
	rectfill(screen, 0, 150, 319, 199, makecol8(255, 255, 255));

	if (button_state & 1)
	    sprintf(text, "pressed    ");
	else
	    sprintf(text, "           ");

	if (button_state & 2)
	    strcat(text, "pressed    ");
	else
	    strcat(text, "           ");

	if (button_state & 4)
	    strcat(text, "pressed");
	else
	    strcat(text, "       ");

	textout_centre(screen, font, "Button 1 - Button 2 - Button 3", SCREEN_W >> 1, 175, makecol8(0, 0, 0));
	textout_centre(screen, font, text, SCREEN_W >> 1, 185, makecol8(0, 0, 0));
	button_state_changes = 0;
    }
}
