// Timing a game

#include <stdio.h>
#include <allegro.h>

volatile int elapsed_seconds;
volatile int boom_seconds;

void increment_seconds()
{
    elapsed_seconds++;
}

END_OF_FUNCTION(increment_seconds);

void decrement_boom()
{
    boom_seconds--;
}

END_OF_FUNCTION(decrement_boom);

void draw_seconds()
{
    textprintf (screen, font, 144, 24, 15, "%d", elapsed_seconds);
    textprintf (screen, font, 304, 32, 15, "%d ", boom_seconds);
    if (boom_seconds == 0)
	textprintf (screen, font, 256, 40, 15, "BOOM !!!");
}

#define CACHE_TIMERS() \
  old_seconds = elapsed_seconds; \
  old_boom = boom_seconds;

int main(void)
{
    int old_seconds, old_boom, end_example;

    allegro_init();
    install_keyboard();
    install_timer();
    set_gfx_mode (GFX_SAFE, 320, 200, 0, 0);
    set_palette (desktop_palette);

    LOCK_VARIABLE(elapsed_seconds);
    LOCK_FUNCTION(increment_seconds);
    install_int_ex(increment_seconds, BPS_TO_TIMER(1));
    LOCK_VARIABLE(boom_seconds);
    LOCK_FUNCTION(decrement_boom);
    install_int_ex(decrement_boom, BPS_TO_TIMER(1000));

    elapsed_seconds = end_example = 0;
    boom_seconds = 10000;

    textprintf (screen, font, 0, 0, 15, "Timing a game. Vivace example.");
    textprintf (screen, font, 0, 24, 15, "Elapsed seconds:");
    textprintf (screen, font, 0, 32, 15, "Remaining miliseconds to big boom...");
    textprintf (screen, font, 0, 48, 15, "Press any key to end example.");

    draw_seconds();

    CACHE_TIMERS();

    while (end_example == 0) {

	if (old_seconds != elapsed_seconds || old_boom != boom_seconds) {
	    CACHE_TIMERS();
	    draw_seconds();
	}
	if (boom_seconds == 0)
	    remove_int(decrement_boom);

	if (keypressed())
	    end_example++;

    }

    return 0;
}
END_OF_MAIN()

