// This example shows how to load datafile objects individually and use them

#include <allegro.h>
#include "1032.h"
#include "1032init.h"
#include "1032tim.h"
#include "1032blit.h"

int actual_cycle;
int end_game;
int monster;
int frame_monster;
fixed monster_pos;
fixed add_pos;

BITMAP *buffer, *txt_buffer;

// Wrapper pointers...
DATAFILE *background_object, *font_object, *music_object, *pal_object,
*sprite_object[10], *walk_object;

int main(void)
{
    init_program();

    end_game = monster = frame_monster = actual_cycle = target_cycle = 0;

    while (end_game == 0) {

	get_keyboard_input();

	draw_one_frame();	/* First do some graphics,  */
	while (target_cycle > actual_cycle)	/* then until up-to-date... */
	    do_one_game_cycle();	/* ... do game cycles.      */
    }

    shutdown_program();

    return 0;
}
END_OF_MAIN()

void get_keyboard_input(void)
{
    if (key[KEY_ESC])
	end_game++;

    if (key[KEY_ENTER] && monster == 0) {
	monster++;
	// Init monster position.
	monster_pos = itofix(-82);
	// Play walk sound
	play_sample(walk_object->dat, 255, 0, 1000, 0);

    }
}

void do_one_game_cycle(void)
{
    int sample_position;

    frame_monster++;
    if (frame_monster > 9)
	frame_monster = 0;

    // See if monster is alive
    if (monster != 0) {
	monster_pos += add_pos;

	//Set up sound panoramization according to position.
	sample_position = fmul(monster_pos,
			       fdiv(itofix(255), itofix(SCREEN_W - 82)));


	adjust_sample(walk_object->dat, 255, fixtoi(sample_position), 1000, 0);

	// Check if we have to 'kill' the monster.
	if (fixtoi(monster_pos) > SCREEN_W) {
	    monster = 0;
	    destroy_sample(walk_object->dat);
	}
    }
    actual_cycle++;
}
