#include <stdio.h>
#include <string.h>
#include <allegro.h>
#include "1033.h"
#include "1033data.h"

MIDI *music;
char *text;

int main(void)
{
    int i = 0;
    char *p, buf[256];
    
    allegro_init();
    install_keyboard();
    install_timer();

    if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) != 0) {
	allegro_message("Sorry, problems initializing sound...\n%s", allegro_error);
	exit(2);
    }
    if (load_our_data() != 0) {
	allegro_message("Sorry, couldn't load the data...");
	exit(3);
    }
    if (set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0) != 0) {
	allegro_message("Couldn't set gfx mode: %s\n", allegro_error);
	exit(1);
    }
    play_midi(music, 1000);

    clear(screen);
    for (p = text; p;) {
	strncpy(buf, text, 250);
	buf[254] = 0;
	p = strchr(buf, '\r');
	if (p)
	    *p = 0;
	textout(screen, font, buf, 0, i, 15);
	i += 10;

	p = strchr(text, '\n');
	if (p) p++;
	text = p;
    }

    readkey();

    unload_our_data();

    allegro_exit();

    return 0;
}
END_OF_MAIN()

