#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <allegro.h>
#include "1033.h"

static char datafile_filename[64];

static void locate_datafile(void)
{
    /* Look, since this example can be run from the main examples dir or 
     * from some src/chap_10/ex_3_* dir, to avoid having duplicated 
     * datafiles we will try loading the data from the current dir, if 
     * not found, 2 dirs up.  But this isn't the point of the example. 
     * The important thing is that you see 'how' you have to load the 
     * data in memory.
     */

    if (file_exists ("datafile.dat", 0, NULL))
	strcpy (datafile_filename, "datafile.dat");
    else if (file_exists ("../../datafile.dat", 0, NULL))
	strcpy (datafile_filename, "../../datafile.dat");
    else {
	allegro_exit();
	printf ("Unable to locate datafile\n");
	exit (1);
    }
}

int load_our_data(void)
{
    PACKFILE *fp;
    int text_size;
    char buffer[64];

    locate_datafile();

    strcpy (buffer, datafile_filename);
    strcat (buffer, "#BINARY_MIDI");     /* e.g. "datafile.dat#BINARY_MIDI" */
    music = load_midi(buffer);

    strcpy (buffer, datafile_filename);
    strcat (buffer, "#BINARY_TEXT");

    // First we need to know the size of the text in bytes to malloc mem
    text_size = file_size(buffer);
    if (text_size == 0)
	return 5;		// Error

    // Malloc the memory
    text = malloc(text_size);
    if (text == NULL)
	return 4;		// Error

    // Clean the memory
    memset(text, 0, sizeof(text));

    // Now we open the file
    fp = pack_fopen(buffer, F_READ_PACKED);
    if (fp == NULL)
	return 3;

    // This reads the data to the buffer
    if (pack_fread(text, text_size, fp) == -1)
	return 2;

    // Remember to close the file
    pack_fclose(fp);

    if (music == NULL)
	return 1;		//Mistake...

    return 0;			// Data loaded.
}

void unload_our_data(void)
{
    free(text);
    destroy_midi(music);
}
